{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module Cooper(Int(..), Atom, Fm, cooper) where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;

newtype Int = Int_of_integer Integer;

integer_of_int :: Int -> Integer;
integer_of_int (Int_of_integer k) = k;

equal_int :: Int -> Int -> Bool;
equal_int k l = integer_of_int k == integer_of_int l;

instance Eq Int where {
  a == b = equal_int a b;
};

times_int :: Int -> Int -> Int;
times_int k l = Int_of_integer (integer_of_int k * integer_of_int l);

class Times a where {
  times :: a -> a -> a;
};

class (Times a) => Dvd a where {
};

instance Times Int where {
  times = times_int;
};

instance Dvd Int where {
};

data Num = One | Bit0 Num | Bit1 Num;

one_int :: Int;
one_int = Int_of_integer (1 :: Integer);

class One a where {
  one :: a;
};

instance One Int where {
  one = one_int;
};

uminus_int :: Int -> Int;
uminus_int k = Int_of_integer (negate (integer_of_int k));

minus_int :: Int -> Int -> Int;
minus_int k l = Int_of_integer (integer_of_int k - integer_of_int l);

zero_int :: Int;
zero_int = Int_of_integer (0 :: Integer);

plus_int :: Int -> Int -> Int;
plus_int k l = Int_of_integer (integer_of_int k + integer_of_int l);

class Uminus a where {
  uminus :: a -> a;
};

class Minus a where {
  minus :: a -> a -> a;
};

class Zero a where {
  zero :: a;
};

class Plus a where {
  plus :: a -> a -> a;
};

class (Plus a) => Semigroup_add a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Ab_semigroup_add a, Cancel_semigroup_add a,
        Minus a) => Cancel_ab_semigroup_add a where {
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class (Times a, Zero a) => Mult_zero a where {
};

class (Times a) => Semigroup_mult a where {
};

class (Ab_semigroup_add a, Semigroup_mult a) => Semiring a where {
};

class (Comm_monoid_add a, Mult_zero a, Semiring a) => Semiring_0 a where {
};

class (Cancel_comm_monoid_add a, Semiring_0 a) => Semiring_0_cancel a where {
};

class (Cancel_semigroup_add a, Minus a, Monoid_add a,
        Uminus a) => Group_add a where {
};

class (Cancel_comm_monoid_add a, Group_add a) => Ab_group_add a where {
};

class (Ab_group_add a, Semiring_0_cancel a) => Ring a where {
};

instance Plus Int where {
  plus = plus_int;
};

instance Semigroup_add Int where {
};

instance Cancel_semigroup_add Int where {
};

instance Ab_semigroup_add Int where {
};

instance Minus Int where {
  minus = minus_int;
};

instance Cancel_ab_semigroup_add Int where {
};

instance Zero Int where {
  zero = zero_int;
};

instance Monoid_add Int where {
};

instance Comm_monoid_add Int where {
};

instance Cancel_comm_monoid_add Int where {
};

instance Mult_zero Int where {
};

instance Semigroup_mult Int where {
};

instance Semiring Int where {
};

instance Semiring_0 Int where {
};

instance Semiring_0_cancel Int where {
};

instance Uminus Int where {
  uminus = uminus_int;
};

instance Group_add Int where {
};

instance Ab_group_add Int where {
};

instance Ring Int where {
};

class (One a, Semigroup_add a) => Numeral a where {
};

instance Numeral Int where {
};

class (One a, Times a) => Power a where {
};

instance Power Int where {
};

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if (0 :: Integer) < l
           then (if (0 :: Integer) < k then divMod (abs k) (abs l)
                  else (case divMod (abs k) (abs l) of {
                         (r, s) ->
                           (if s == (0 :: Integer)
                             then (negate r, (0 :: Integer))
                             else (negate r - (1 :: Integer), l - s));
                       }))
           else (if l == (0 :: Integer) then ((0 :: Integer), k)
                  else apsnd negate
                         (if k < (0 :: Integer) then divMod (abs k) (abs l)
                           else (case divMod (abs k) (abs l) of {
                                  (r, s) ->
                                    (if s == (0 :: Integer)
                                      then (negate r, (0 :: Integer))
                                      else (negate r - (1 :: Integer),
     negate l - s));
                                })))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_int :: Int -> Int -> Int;
divide_int k l =
  Int_of_integer (divide_integer (integer_of_int k) (integer_of_int l));

class Divide a where {
  divide :: a -> a -> a;
};

instance Divide Int where {
  divide = divide_int;
};

modulo_integer :: Integer -> Integer -> Integer;
modulo_integer k l = snd (divmod_integer k l);

modulo_int :: Int -> Int -> Int;
modulo_int k l =
  Int_of_integer (modulo_integer (integer_of_int k) (integer_of_int l));

class (Divide a, Dvd a) => Modulo a where {
  modulo :: a -> a -> a;
};

instance Modulo Int where {
  modulo = modulo_int;
};

less_eq_int :: Int -> Int -> Bool;
less_eq_int k l = integer_of_int k <= integer_of_int l;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

less_int :: Int -> Int -> Bool;
less_int k l = integer_of_int k < integer_of_int l;

instance Ord Int where {
  less_eq = less_eq_int;
  less = less_int;
};

class (Semiring_0 a) => Semiring_no_zero_divisors a where {
};

class (Semigroup_mult a, Power a) => Monoid_mult a where {
};

class (Monoid_mult a, Numeral a, Semiring a) => Semiring_numeral a where {
};

class (One a, Zero a) => Zero_neq_one a where {
};

class (Semiring_numeral a, Semiring_0 a, Zero_neq_one a) => Semiring_1 a where {
};

class (Semiring_1 a,
        Semiring_no_zero_divisors a) => Semiring_1_no_zero_divisors a where {
};

class (Semigroup_mult a) => Ab_semigroup_mult a where {
};

class (Ab_semigroup_mult a, Semiring a) => Comm_semiring a where {
};

class (Comm_semiring a, Semiring_0 a) => Comm_semiring_0 a where {
};

class (Comm_semiring_0 a,
        Semiring_0_cancel a) => Comm_semiring_0_cancel a where {
};

class (Semiring_0_cancel a, Semiring_1 a) => Semiring_1_cancel a where {
};

class (Ab_semigroup_mult a, Monoid_mult a, Dvd a) => Comm_monoid_mult a where {
};

class (Comm_monoid_mult a, Comm_semiring_0 a,
        Semiring_1 a) => Comm_semiring_1 a where {
};

class (Comm_semiring_0_cancel a, Comm_semiring_1 a,
        Semiring_1_cancel a) => Comm_semiring_1_cancel a where {
};

class (Comm_semiring_1_cancel a,
        Semiring_1_no_zero_divisors a) => Semidom a where {
};

instance Semiring_no_zero_divisors Int where {
};

instance Monoid_mult Int where {
};

instance Semiring_numeral Int where {
};

instance Zero_neq_one Int where {
};

instance Semiring_1 Int where {
};

instance Semiring_1_no_zero_divisors Int where {
};

instance Ab_semigroup_mult Int where {
};

instance Comm_semiring Int where {
};

instance Comm_semiring_0 Int where {
};

instance Comm_semiring_0_cancel Int where {
};

instance Semiring_1_cancel Int where {
};

instance Comm_monoid_mult Int where {
};

instance Comm_semiring_1 Int where {
};

instance Comm_semiring_1_cancel Int where {
};

instance Semidom Int where {
};

class (Semiring_no_zero_divisors a) => Semiring_no_zero_divisors_cancel a where {
};

class (Divide a, Semidom a,
        Semiring_no_zero_divisors_cancel a) => Semidom_divide a where {
};

instance Semiring_no_zero_divisors_cancel Int where {
};

instance Semidom_divide Int where {
};

class (Semidom_divide a) => Algebraic_semidom a where {
};

class (Comm_semiring_1_cancel a, Modulo a) => Semiring_modulo a where {
};

class (Algebraic_semidom a, Semiring_modulo a) => Semidom_modulo a where {
};

instance Algebraic_semidom Int where {
};

instance Semiring_modulo Int where {
};

instance Semidom_modulo Int where {
};

data Atom = Le Int [Int] | Dvd Int Int [Int] | NDvd Int Int [Int];

equal_atom :: Atom -> Atom -> Bool;
equal_atom (Dvd x21 x22 x23) (NDvd x31 x32 x33) = False;
equal_atom (NDvd x31 x32 x33) (Dvd x21 x22 x23) = False;
equal_atom (Le x11 x12) (NDvd x31 x32 x33) = False;
equal_atom (NDvd x31 x32 x33) (Le x11 x12) = False;
equal_atom (Le x11 x12) (Dvd x21 x22 x23) = False;
equal_atom (Dvd x21 x22 x23) (Le x11 x12) = False;
equal_atom (NDvd x31 x32 x33) (NDvd y31 y32 y33) =
  equal_int x31 y31 && equal_int x32 y32 && x33 == y33;
equal_atom (Dvd x21 x22 x23) (Dvd y21 y22 y23) =
  equal_int x21 y21 && equal_int x22 y22 && x23 == y23;
equal_atom (Le x11 x12) (Le y11 y12) = equal_int x11 y11 && x12 == y12;

instance Eq Atom where {
  a == b = equal_atom a b;
};

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

newtype Nat = Nat Integer;

data Fm a = TrueF | FalseF | Atom a | And (Fm a) (Fm a) | Or (Fm a) (Fm a)
  | Neg (Fm a) | ExQ (Fm a);

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

nat :: Int -> Nat;
nat k = Nat (max (0 :: Integer) (integer_of_int k));

equal_fm :: forall a. (Eq a) => Fm a -> Fm a -> Bool;
equal_fm (Neg x6) (ExQ x7) = False;
equal_fm (ExQ x7) (Neg x6) = False;
equal_fm (Or x51 x52) (ExQ x7) = False;
equal_fm (ExQ x7) (Or x51 x52) = False;
equal_fm (Or x51 x52) (Neg x6) = False;
equal_fm (Neg x6) (Or x51 x52) = False;
equal_fm (And x41 x42) (ExQ x7) = False;
equal_fm (ExQ x7) (And x41 x42) = False;
equal_fm (And x41 x42) (Neg x6) = False;
equal_fm (Neg x6) (And x41 x42) = False;
equal_fm (And x41 x42) (Or x51 x52) = False;
equal_fm (Or x51 x52) (And x41 x42) = False;
equal_fm (Atom x3) (ExQ x7) = False;
equal_fm (ExQ x7) (Atom x3) = False;
equal_fm (Atom x3) (Neg x6) = False;
equal_fm (Neg x6) (Atom x3) = False;
equal_fm (Atom x3) (Or x51 x52) = False;
equal_fm (Or x51 x52) (Atom x3) = False;
equal_fm (Atom x3) (And x41 x42) = False;
equal_fm (And x41 x42) (Atom x3) = False;
equal_fm FalseF (ExQ x7) = False;
equal_fm (ExQ x7) FalseF = False;
equal_fm FalseF (Neg x6) = False;
equal_fm (Neg x6) FalseF = False;
equal_fm FalseF (Or x51 x52) = False;
equal_fm (Or x51 x52) FalseF = False;
equal_fm FalseF (And x41 x42) = False;
equal_fm (And x41 x42) FalseF = False;
equal_fm FalseF (Atom x3) = False;
equal_fm (Atom x3) FalseF = False;
equal_fm TrueF (ExQ x7) = False;
equal_fm (ExQ x7) TrueF = False;
equal_fm TrueF (Neg x6) = False;
equal_fm (Neg x6) TrueF = False;
equal_fm TrueF (Or x51 x52) = False;
equal_fm (Or x51 x52) TrueF = False;
equal_fm TrueF (And x41 x42) = False;
equal_fm (And x41 x42) TrueF = False;
equal_fm TrueF (Atom x3) = False;
equal_fm (Atom x3) TrueF = False;
equal_fm TrueF FalseF = False;
equal_fm FalseF TrueF = False;
equal_fm (ExQ x7) (ExQ y7) = equal_fm x7 y7;
equal_fm (Neg x6) (Neg y6) = equal_fm x6 y6;
equal_fm (Or x51 x52) (Or y51 y52) = equal_fm x51 y51 && equal_fm x52 y52;
equal_fm (And x41 x42) (And y41 y42) = equal_fm x41 y41 && equal_fm x42 y42;
equal_fm (Atom x3) (Atom y3) = x3 == y3;
equal_fm FalseF FalseF = True;
equal_fm TrueF TrueF = True;

or :: forall a. (Eq a) => Fm a -> Fm a -> Fm a;
or phi_1 phi_2 =
  (if equal_fm phi_1 FalseF then phi_2
    else (if equal_fm phi_2 FalseF then phi_1
           else (if equal_fm phi_1 TrueF || equal_fm phi_2 TrueF then TrueF
                  else Or phi_1 phi_2)));

find :: forall a. (a -> Bool) -> [a] -> Maybe a;
find uu [] = Nothing;
find p (x : xs) = (if p x then Just x else find p xs);

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

upto_aux :: Int -> Int -> [Int] -> [Int];
upto_aux i j js =
  (if less_int j i then js else upto_aux i (minus_int j one_int) (j : js));

upto :: Int -> Int -> [Int];
upto i j = upto_aux i j [];

and :: forall a. (Eq a) => Fm a -> Fm a -> Fm a;
and phi_1 phi_2 =
  (if equal_fm phi_1 TrueF then phi_2
    else (if equal_fm phi_2 TrueF then phi_1
           else (if equal_fm phi_1 FalseF || equal_fm phi_2 FalseF then FalseF
                  else And phi_1 phi_2)));

neg :: forall a. (Eq a) => Fm a -> Fm a;
neg phi =
  (if equal_fm phi TrueF then FalseF
    else (if equal_fm phi FalseF then TrueF else Neg phi));

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

funpow :: forall a. Nat -> (a -> a) -> a -> a;
funpow n f =
  (if equal_nat n zero_nat then id else f . funpow (minus_nat n one_nat) f);

min_inf :: Fm Atom -> Fm Atom;
min_inf (And phi_1 phi_2) = and (min_inf phi_1) (min_inf phi_2);
min_inf (Or phi_1 phi_2) = or (min_inf phi_1) (min_inf phi_2);
min_inf (Atom (Le i (k : ks))) =
  (if less_int k zero_int then TrueF
    else (if less_int zero_int k then FalseF else Atom (Le i (zero_int : ks))));
min_inf TrueF = TrueF;
min_inf FalseF = FalseF;
min_inf (Atom (Le va [])) = Atom (Le va []);
min_inf (Atom (Dvd va vb vc)) = Atom (Dvd va vb vc);
min_inf (Atom (NDvd va vb vc)) = Atom (NDvd va vb vc);
min_inf (Neg v) = Neg v;
min_inf (ExQ v) = ExQ v;

uminus_list :: forall a. (Uminus a, Zero a) => [a] -> [a];
uminus_list = map uminus;

neg_Z :: Atom -> Fm Atom;
neg_Z (Le i ks) = Atom (Le (minus_int one_int i) (uminus_list ks));
neg_Z (Dvd d i ks) = Atom (NDvd d i ks);
neg_Z (NDvd d i ks) = Atom (Dvd d i ks);

nnf :: Fm Atom -> Fm Atom;
nnf (And phi_1 phi_2) = And (nnf phi_1) (nnf phi_2);
nnf (Or phi_1 phi_2) = Or (nnf phi_1) (nnf phi_2);
nnf (Neg TrueF) = FalseF;
nnf (Neg FalseF) = TrueF;
nnf (Neg (Neg phi)) = nnf phi;
nnf (Neg (And phi_1 phi_2)) = Or (nnf (Neg phi_1)) (nnf (Neg phi_2));
nnf (Neg (Or phi_1 phi_2)) = And (nnf (Neg phi_1)) (nnf (Neg phi_2));
nnf (Neg (Atom a)) = neg_Z a;
nnf TrueF = TrueF;
nnf FalseF = FalseF;
nnf (Atom v) = Atom v;
nnf (Neg (ExQ va)) = Neg (ExQ va);
nnf (ExQ v) = ExQ v;

map_fm :: forall a b. (a -> b) -> Fm a -> Fm b;
map_fm f TrueF = TrueF;
map_fm f FalseF = FalseF;
map_fm f (Atom x3) = Atom (f x3);
map_fm f (And x41 x42) = And (map_fm f x41) (map_fm f x42);
map_fm f (Or x51 x52) = Or (map_fm f x51) (map_fm f x52);
map_fm f (Neg x6) = Neg (map_fm f x6);
map_fm f (ExQ x7) = ExQ (map_fm f x7);

list_conj :: forall a. (Eq a) => [Fm a] -> Fm a;
list_conj fs = foldr and fs TrueF;

list_disj :: forall a. (Eq a) => [Fm a] -> Fm a;
list_disj fs = foldr or fs FalseF;

lcm_integer :: Integer -> Integer -> Integer;
lcm_integer a b =
  divide_integer (Prelude.abs a * Prelude.abs b) (Prelude.gcd a b);

lcm_int :: Int -> Int -> Int;
lcm_int (Int_of_integer x) (Int_of_integer y) =
  Int_of_integer (lcm_integer x y);

zlcms :: [Int] -> Int;
zlcms [] = one_int;
zlcms (i : is) = lcm_int i (zlcms is);

hd_coeff :: Atom -> Int;
hd_coeff (Le i ks) = (case ks of {
                       [] -> zero_int;
                       k : _ -> k;
                     });
hd_coeff (Dvd d i ks) = (case ks of {
                          [] -> zero_int;
                          k : _ -> k;
                        });
hd_coeff (NDvd d i ks) = (case ks of {
                           [] -> zero_int;
                           k : _ -> k;
                         });

atoms_0 :: Fm Atom -> [Atom];
atoms_0 TrueF = [];
atoms_0 FalseF = [];
atoms_0 (Atom a) = (if not (equal_int (hd_coeff a) zero_int) then [a] else []);
atoms_0 (And phi_1 phi_2) = atoms_0 phi_1 ++ atoms_0 phi_2;
atoms_0 (Or phi_1 phi_2) = atoms_0 phi_1 ++ atoms_0 phi_2;
atoms_0 (Neg phi) = atoms_0 phi;

lbounds :: [Atom] -> [(Int, [Int])];
lbounds asa =
  concatMap
    (\ a -> (case a of {
              Le _ [] -> [];
              Le i (k : ks) -> (if less_int zero_int k then [(i, ks)] else []);
              Dvd _ _ _ -> [];
              NDvd _ _ _ -> [];
            }))
    asa;

divisor :: Atom -> Int;
divisor (Le i ks) = one_int;
divisor (Dvd d i ks) = d;
divisor (NDvd d i ks) = d;

zipwith0 ::
  forall a b c. (Zero a, Zero b) => (a -> b -> c) -> [a] -> [b] -> [c];
zipwith0 f [] [] = [];
zipwith0 f (x : xs) (y : ys) = f x y : zipwith0 f xs ys;
zipwith0 f (x : xs) [] = f x zero : zipwith0 f xs [];
zipwith0 f [] (y : ys) = f zero y : zipwith0 f [] ys;

plus_list :: forall a. (Plus a, Zero a) => [a] -> [a] -> [a];
plus_list = zipwith0 plus;

asubst :: Int -> [Int] -> Atom -> Atom;
asubst ia ksa (Le i (k : ks)) =
  Le (minus_int i (times_int k ia)) (plus_list (map (times_int k) ksa) ks);
asubst ia ksa (Dvd d i (k : ks)) =
  Dvd d (plus_int i (times_int k ia)) (plus_list (map (times_int k) ksa) ks);
asubst ia ksa (NDvd d i (k : ks)) =
  NDvd d (plus_int i (times_int k ia)) (plus_list (map (times_int k) ksa) ks);
asubst i ks (Le v []) = Le v [];
asubst i ks (Dvd v va []) = Dvd v va [];
asubst i ks (NDvd v va []) = NDvd v va [];

qe_cooper_1 :: Fm Atom -> Fm Atom;
qe_cooper_1 phi =
  let {
    asa = atoms_0 phi;
    d = zlcms (map divisor asa);
    ls = lbounds asa;
  } in or (list_disj
            (map (\ n -> map_fm (asubst n []) (min_inf phi))
              (upto zero_int (minus_int d one_int))))
         (list_disj
           (map (\ (i, ks) ->
                  list_disj
                    (map (\ n ->
                           map_fm (asubst (plus_int i n) (uminus_list ks)) phi)
                      (upto zero_int (minus_int d one_int))))
             ls));

lift_nnf_qe :: (Fm Atom -> Fm Atom) -> Fm Atom -> Fm Atom;
lift_nnf_qe qe (And phi_1 phi_2) =
  and (lift_nnf_qe qe phi_1) (lift_nnf_qe qe phi_2);
lift_nnf_qe qe (Or phi_1 phi_2) =
  or (lift_nnf_qe qe phi_1) (lift_nnf_qe qe phi_2);
lift_nnf_qe qe (Neg phi) = neg (lift_nnf_qe qe phi);
lift_nnf_qe qe (ExQ phi) = qe (nnf (lift_nnf_qe qe phi));
lift_nnf_qe qe TrueF = TrueF;
lift_nnf_qe qe FalseF = FalseF;
lift_nnf_qe qe (Atom v) = Atom v;

sgn_int :: Int -> Int;
sgn_int i =
  (if equal_int i zero_int then zero_int
    else (if less_int zero_int i then one_int else uminus_int one_int));

abs_int :: Int -> Int;
abs_int i = (if less_int i zero_int then uminus_int i else i);

hd_coeff1 :: Int -> Atom -> Atom;
hd_coeff1 m (Le i (k : ks)) =
  (if equal_int k zero_int then Le i (k : ks)
    else let {
           ma = divide_int m (abs_int k);
         } in Le (times_int ma i) (sgn_int k : map (times_int ma) ks));
hd_coeff1 m (Dvd d i (k : ks)) =
  (if equal_int k zero_int then Dvd d i (k : ks)
    else let {
           ma = divide_int m k;
         } in Dvd (times_int ma d) (times_int ma i)
                (one_int : map (times_int ma) ks));
hd_coeff1 m (NDvd d i (k : ks)) =
  (if equal_int k zero_int then NDvd d i (k : ks)
    else let {
           ma = divide_int m k;
         } in NDvd (times_int ma d) (times_int ma i)
                (one_int : map (times_int ma) ks));
hd_coeff1 uu (Le v []) = Le v [];
hd_coeff1 uu (Dvd v va []) = Dvd v va [];
hd_coeff1 uu (NDvd v va []) = NDvd v va [];

hd_coeffs1 :: Fm Atom -> Fm Atom;
hd_coeffs1 phi =
  let {
    m = zlcms (map hd_coeff (atoms_0 phi));
  } in And (Atom (Dvd m zero_int [one_int])) (map_fm (hd_coeff1 m) phi);

qe_cooper :: Fm Atom -> Fm Atom;
qe_cooper = lift_nnf_qe (qe_cooper_1 . hd_coeffs1);

sum_list :: forall a. (Monoid_add a) => [a] -> a;
sum_list xs = foldr plus xs zero;

iprod :: forall a. (Ring a) => [a] -> [a] -> a;
iprod xs ys = sum_list (map (\ (a, b) -> times a b) (zip xs ys));

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

constr_to_atom :: Int -> (String, ([(Int, Int)], Int)) -> Atom;
constr_to_atom n (s, (cs, c)) =
  let {
    xs = map (\ i -> (case find (\ p -> equal_int (snd p) i) cs of {
                       Nothing -> zero_int;
                       Just a -> fst a;
                     }))
           (upto zero_int n);
  } in (if s == "GEQ" then Le c xs
         else (if s == "LEQ" then Le (uminus_int c) (map uminus_int xs)
                else (error :: forall a. String -> (() -> a) -> a) "unsupported"
                       (\ _ -> Le zero_int [])));

max_var_c :: (String, ([(Int, Int)], Int)) -> Int;
max_var_c (s, (cs, c)) = fold (max . snd) cs zero_int;

max_var_cs :: [(String, ([(Int, Int)], Int))] -> Int;
max_var_cs cs = fold (max . max_var_c) cs zero_int;

constrs_to_fm :: [(String, ([(Int, Int)], Int))] -> Fm Atom;
constrs_to_fm cs =
  let {
    n = max_var_cs cs;
  } in funpow (plus_nat (nat n) one_nat) ExQ
         (list_conj (map (Atom . constr_to_atom n) cs));

interpret :: forall a b. (a -> [b] -> Bool) -> Fm a -> [b] -> Bool;
interpret h TrueF xs = True;
interpret h FalseF xs = False;
interpret h (Atom a) xs = h a xs;
interpret h (And phi_1 phi_2) xs = interpret h phi_1 xs && interpret h phi_2 xs;
interpret h (Or phi_1 phi_2) xs = interpret h phi_1 xs || interpret h phi_2 xs;
interpret h (Neg phi) xs = not (interpret h phi xs);
interpret h (ExQ phi) xs =
  (error :: forall a. String -> (() -> a) -> a) "quantifier" (\ _ -> True);

dvd :: forall a. (Eq a, Semidom_modulo a) => a -> a -> Bool;
dvd a b = modulo b a == zero;

i_Z :: Atom -> [Int] -> Bool;
i_Z (Le i ks) xs = less_eq_int i (iprod ks xs);
i_Z (Dvd d i ks) xs = dvd d (plus_int i (iprod ks xs));
i_Z (NDvd d i ks) xs = not (dvd d (plus_int i (iprod ks xs)));

cooper_sat :: Fm Atom -> Bool;
cooper_sat f = interpret i_Z (qe_cooper f) [];

cooper :: [(String, ([(Int, Int)], Int))] -> Bool;
cooper = cooper_sat . constrs_to_fm;

}
