import BB_test
import System.Environment
import Data.String
import qualified Cooper

-- run './Main < example_inputs/example.txt' for incremental version
-- ./Main non_incr for non-incremental version
-- ./Main cooper for using Cooper's algoritms
main = do
    as <- getArgs
    let f = case as of ["non_incr"] -> show . helper bnb_non_incr
                       ["cooper"] -> show . Cooper.cooper . cooper_helper
                       _ -> show . helper bnb_incr
    interact $ (\s -> unfold f s ++ "\n")
  where unfold f = f . lines

helper f (z:x:y:zs) = f z' (read x) (read y)
  where z' = map (\(x,y,z) -> create_constraint x y z) $ read z

cooper_helper (z:x:y:zs) = map f $ read z
  where f (s, vs, l) = (s, (map g vs, Cooper.Int_of_integer l))
        g (x,y) = (Cooper.Int_of_integer x, Cooper.Int_of_integer y)
