theory Code
  imports Ord.Branch_and_Bound
  Deriving.Compare_Rat
  Show.Show_Instances
begin

section \<open>Code setup and examples\<close>

declare Lcm_fin.set_eq_fold[code_unfold] 
derive (eq) ceq rat atom QDelta
derive (linorder) compare_order QDelta
derive compare_order atom 
derive ccompare rat atom QDelta
derive (rbt) set_impl rat atom QDelta

lemma in_ints_code_unfold[code_unfold]: "(x \<in> \<int>) = is_int_rat x" 
  by simp

fun create_constraint :: "_ \<Rightarrow> _ \<Rightarrow> _ \<Rightarrow> constraint" where
  "create_constraint c xs n = (let c' = if c = STR ''LEQ'' then LEQ
                                        else if c = STR ''GEQ'' then GEQ
                                        else EQ in
    (c' (foldr (\<lambda>(f, x) p. lp_monom (rat_of_int (int_of_integer f)) (nat_of_integer x) + p) xs 0) (rat_of_int (int_of_integer n))))"

value "create_constraint STR ''GEQ'' [(1,0),(-1,2),(-1,0)] 3"

(* the method presburger can also solve non-presburger arithmetic stuff ?!? *)
lemma 
  fixes x\<^sub>1:: int
  shows "\<not> (let u = 3 * x\<^sub>1 + 3 * x\<^sub>2 + 3 * x\<^sub>3 + 3 * x\<^sub>4 + 3 * x\<^sub>5 + 3 * x\<^sub>6 + 3 * x\<^sub>7 + 3 * x\<^sub>8 + 3 * x\<^sub>9 + 3 * x\<^sub>1\<^sub>0 + 3 * x\<^sub>1\<^sub>1 
   + 3 * x\<^sub>1\<^sub>2 + 3 * x\<^sub>1\<^sub>3 + 3 * x\<^sub>1\<^sub>4 + 3 * x\<^sub>1\<^sub>5 + 3 * x\<^sub>1\<^sub>6 + 3 * x\<^sub>1\<^sub>7 + 3 * x\<^sub>1\<^sub>8 + 3 * x\<^sub>1\<^sub>9 + 3 * x\<^sub>2\<^sub>0 in u \<le> 2 \<and> u \<ge> 1)"
  unfolding Let_def by presburger

definition bnb_non_incr where
  "bnb_non_incr cs is as = (let
      is = map nat_of_integer is;
      as = map nat_of_integer as
     in (case branch_and_bound cs is of
       Some v \<Rightarrow> Some (map (\<lambda>i. (integer_of_nat i, map_prod integer_of_int integer_of_int (quotient_of (v i)))) as)
     | None \<Rightarrow> None))"

definition bnb_incr
where "bnb_incr cs Is xs = (
  let Bnd = compute_bound_num_of_vars cs;
    Is = map nat_of_integer Is;
    xs = map nat_of_integer xs;
   (cs', lb_m, ub_m, s) = bnb_state_init cs Is (\<lambda> _. -Bnd) (\<lambda> _. Bnd);
   v = case_sum (\<lambda>_. None) (\<lambda>s. the (bnb_state_core_p cs' Is lb_m ub_m s)) s in
   map_option (\<lambda>v. map (\<lambda>x. (integer_of_nat x, map_prod integer_of_int integer_of_int (quotient_of (v x)))) xs) v)"

export_code bnb_incr bnb_non_incr create_constraint in Haskell module_name BB_test
(*
ML \<open>
val gen_files = Generated_Files.get_files (Proof_Context.theory_of @{context})
val output_dir = Path.explode "~/output_hs/"
\<close>

(* The next line creates output_dir and writes the files there *)
ML \<open>map (Generated_Files.write_file output_dir) gen_files\<close>
*)

end
